/////////////////////////////////////////////////////////////////////////////
//
// FILE NAME
//   EP_NodeStore.hh
//
// AUTHORS
//    Y. Sato, A. Shishlo
//
// CREATED
//    01/21/2004
//
// DESCRIPTION
//    EP_NodeStore class - singleton to keep references 
//    to the EP_Node instances.
//
///////////////////////////////////////////////////////////////////////////// 

#ifndef EP_NODE_STORE_H
#define EP_NODE_STORE_H

/////////////////////////////////////////////////////////////////////////////
//
// include files
//
/////////////////////////////////////////////////////////////////////////////
#include "EP_Node.hh"


class EP_NodeStore
{
 public:

  static EP_NodeStore* getEP_NodeStore();

  int addEP_Node(EP_Node* epN);

  EP_Node* getEP_Node(int index);

  int getSize();

  ~EP_NodeStore();

 protected:

  //constructor
  EP_NodeStore();

 private:

  static  EP_NodeStore* epNodeStore;

  int nEP_Nodes;
  EP_Node** epNodes;
};


///////////////////////////////////////////////////////////////////////////
//
// END OF FILE
//
///////////////////////////////////////////////////////////////////////////

#endif   // EP_NODE_STORE_H


