//////////////////////////////// -*- C++ -*- //////////////////////////////
//
// FILE NAME
//    PhiGrid3D.cc
//
// AUTHOR
//    Y. Sato, A. Shishlo
//
// CREATED
//    06/09/2003
//
// DESCRIPTION
//    The subclass of Grid3D class to handle
//    adding boundary potential
//
///////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
//
// INCLUDE FILES
//
///////////////////////////////////////////////////////////////////////////

#include "PhiGrid3D.hh"

PhiGrid3D::PhiGrid3D(int nZ, EP_Boundary* boundaryIn) :
  Grid3D(nZ,boundaryIn)
{

}

PhiGrid3D::~PhiGrid3D()
{
}

//add the boundary potential to the existing one
void PhiGrid3D::addBoundaryPotential()
{
  for(int i=0; i < nZ_; i++){
    boundary->addBoundaryPotential(getSlice2D(i),0,getBinsX()-1,0,getBinsY()-1);
  }
}

///////////////////////////////////////////////////////////////////////////
//
// END OF FILE
//
///////////////////////////////////////////////////////////////////////////
