//////////////////////////////// -*- C++ -*- //////////////////////////////
//
// FILE NAME
//    absrbSurface.cc
//
// AUTHOR
//    A. Shishlo, Y. Sato
//
// CREATED
//    04/01/2003
//
// DESCRIPTION
//    Source code for the subclass "absrbSurface" used to ramove
//    macroparticles that across the surface in the class EPnode
//
///////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////
//
// INCLUDE FILES
//
///////////////////////////////////////////////////////////////////////////

#include "absrbSurface.hh"

///////////////////////////////////////////////////////////////////////////
//
// NAME
//   absrbSurface::absrbSurface()
//   absrbSurface::~absrbSurface()
//
// DESCRIPTION
//   Constructor and Desctructor
//
// RETURNS
//   Nothing.
//
///////////////////////////////////////////////////////////////////////////

absrbSurface::absrbSurface()
{
}

absrbSurface::~absrbSurface()
{
}

///////////////////////////////////////////////////////////////////////////
//
// NAME
//   absrbSurface::impact
//
// DESCRIPTION
//   remove macropartices which cross the given surface at position r_v
//   from the list of macroparticles in eBunch
//
// RETURNS
//   Nothing.
//
// REMARKS
//   Please use "eb->compress();" AFTER the LOOP usage of this method to eBunch
//   not to reorder the index of eBunch inside the loop
///////////////////////////////////////////////////////////////////////////

void absrbSurface::impact(int index, eBunch* eb, double* r_v,double* n_v)
{
  eb->deleteParticle(index);
}

///////////////////////////////////////////////////////////////////////////
//
// END OF FILE
//
///////////////////////////////////////////////////////////////////////////
