//////////////////////////////// -*- C++ -*- //////////////////////////////
//
// FILE NAME
//    baseSurface.cc
//
// AUTHOR
//    A. Shishlo
//
// CREATED
//    03/31/2003
//
// DESCRIPTION
//    Source code for the class "baseSurface" used to manage 
//    macro particles which hit the surface in the class EPnode
//
///////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
//
// include files
//
/////////////////////////////////////////////////////////////////////////////

#include "baseSurface.hh"

///////////////////////////////////////////////////////////////////////////
//
// NAME
//   baseSurface::baseSurface()
//   baseSurface::~baseSurface()
//
// DESCRIPTION
//   Constructor and Desctructor
//
// RETURNS
//   Nothing.
//
///////////////////////////////////////////////////////////////////////////

baseSurface::baseSurface()
{
}

baseSurface::~baseSurface()
{
}

///////////////////////////////////////////////////////////////////////////
//
// NAME
//   baseSurface::impact
//
// DESCRIPTION
//   removes the macroparticles which hit the surface and add newly produced
//   macro particles at the hitted points. The process to make new macro 
//   particles is defind in each subclasses
//
// RETURNS
//   Nothing.
//
///////////////////////////////////////////////////////////////////////////

void baseSurface::impact(int index, eBunch* eb, double* r_v,double* n_v)
{
}


void baseSurface::setDeathFunction(Function* func)
{
}

void baseSurface::setDeathProbability(double p_death_defaultIn)
{
}  
  
void baseSurface::setNewBornNumberFunction(Function* func)
{
}

void baseSurface::setNewBornNumber(int n_new_born_defaultIn)
{
}

void baseSurface::setMacroPartsHardLimitN(int macroPartsMaxNIn)
{
}
///////////////////////////////////////////////////////////////////////////
//
// END OF FILE
//
///////////////////////////////////////////////////////////////////////////
